unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, FileCtrl, ExtCtrls, ComCtrls,shellapi,myff;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    DriveComboBox1: TDriveComboBox;
    Button1: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    CheckBox1: TCheckBox;
    Edit3: TEdit;
    CheckBox2: TCheckBox;
    Edit4: TEdit;
    Edit5: TEdit;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    ListBox1: TListView;
    stb: TStatusBar;
    Bevel1: TBevel;
    RadioButton2: TRadioButton;
    RadioButton1: TRadioButton;
    Label1: TLabel;
    GroupBox1: TGroupBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    CheckBox7: TCheckBox;
    Image1: TImage;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Image1Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    procedure setdir(a:string;var b:boolean);
    procedure addfile(a:string;b:twin32finddata; var c: boolean);
  end;

var
  Form1: TForm1;
  grep   : tmyff;
  attrstr : array [0..faanyfile] of string[5];
implementation


{$R *.DFM}

procedure tform1.addfile(a:string;b:twin32finddata; var c: boolean);
begin
     with listbox1.items.add do begin
          caption := b.cfilename;
          subitems.add((inttostr((b.nfilesizelow+1023) shr 10))+' KB');
          subitems.add(attrstr[b.dwfileattributes and faanyfile]);
          subitems.add(formatdatetime('c',grep.convertdatetime(b.ftlastwritetime)));
          subitems.add(a);
     end;
end;

procedure tform1.setdir(a:string;var b:boolean);
begin
     stb.simpletext :='Scanning '+a;
     stb.update;
     b := (getasynckeystate(vk_escape) and not 1) <> 0;
end;

procedure TForm1.Button1Click(Sender: TObject);
var attr : integer;
    sr : string;
begin
{      screen.cursor := crhourglass;
//      grep(drivecombobox1.drive+':\',edit2.text,edit1.text,listbox1.items,
//      checkbox3.checked,checkbox2.checked,checkbox4.checked,checkbox1.checked,
//      radiobutton1.checked,strtodatetime(edit4.text),strtodatetime(edit5.text),
//      strtoint(edit3.text),setdir);
      screen.cursor := crdefault;}
      listbox1.items.beginupdate;
      listbox1.items.clear;
      attr := faarchive;
      sr := caption;
      caption := '<ESC> to cancel...';
      if checkbox5.checked then attr := attr or fahidden;
      if checkbox6.checked then attr := attr or fareadonly;
      if checkbox7.checked then attr := attr or fasysfile;
      with grep do begin
           attributes := attr;
           if checkbox4.checked then findstring := edit1.text else findstring := '';
           Filemask := edit2.text;
           recursedirs := checkbox3.checked;
           minfilesize := 0;
           maxfilesize := maxint;
           if checkbox1.checked then begin
              if radiobutton1.checked then maxfilesize := strtointdef(edit3.text,maxint shr 10) shl 10
              else minfilesize := strtointdef(edit3.text,0) shl 10;
           end;
           firsttime := 0;
           lasttime := maxint;
           if checkbox2.checked then begin
              try
                 firsttime := strtodatetime(edit4.text);
              except
                    firsttime := 0;
              end;
              try
                 lasttime := strtodatetime(edit5.text);
              except
                    lasttime := maxint;
              end;
           end;
           find(drivecombobox1.drive+':\');
      end;
      listbox1.items.endupdate;
      stb.simpletext := inttostr(listbox1.items.count)+' File(s) found';
      caption := sr;
end;

procedure TForm1.FormCreate(Sender: TObject);
var ct : integer;
begin
     for ct := 0 to faanyfile do begin
         attrstr[ct] := '-----';
         if (ct and faarchive) = faarchive then attrstr[ct][1]:='a';
         if (ct and fasysfile) = fasysfile then attrstr[ct][2]:='s';
         if (ct and fahidden) = fahidden then attrstr[ct][3]:='h';
         if (ct and fareadonly) = fareadonly then attrstr[ct][4]:='r';
         if (ct and fadirectory) = fadirectory then attrstr[ct][5]:='d';
     end;
     grep := tmyff.create;
     grep.onchdir := setdir;
     grep.onaddfile := addfile;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
     listbox1.items.beginupdate;
     listbox1.items.clear;
     listbox1.items.beginupdate;
     grep.free;
end;

procedure TForm1.Image1Click(Sender: TObject);
begin
ShellExecute(Application.Handle,PChar('open'),PChar('http://home.t-online.de/home/mirbir.st/'),PChar(''),nil,SW_NORMAL);

end;

end.
