{
  
   Project  : ODGE
   Unit Name: uodge_fullsize

 /--------------------------------------------------------------\
 | Purpose    : DISPLAY AN IMAGE IN ITS ORIGINAL SIZE           |
 | Author     : Olivier DAHAN 100531.163@compuserve.com         |
 +--------------------------------------------------------------+
 | History    : V 1.0                                           |
 | Created on : 16/04/98 02:09:27                               |
 \--------------------------------------------------------------/
}

unit uodge_fullsize;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons;

type
  TFODGEFullsize = class(TForm)
    Panel1: TPanel;
    BitBtn1: TBitBtn;
    CheckBox1: TCheckBox;
    Label1: TLabel;
    ScrollBox1: TScrollBox;
    Image1: TImage;
    procedure CheckBox1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  FODGEFullsize: TFODGEFullsize;

implementation

{$R *.DFM}

procedure TFODGEFullsize.CheckBox1Click(Sender: TObject);
begin
image1.Stretch := Checkbox1.Checked;
if checkbox1.checked then
 begin
  scrollbox1.HorzScrollBar.Range := 0;
  scrollbox1.VertScrollBar.Range := 0;
 end else
 begin
  scrollbox1.HorzScrollBar.Range := image1.picture.Width;
  scrollbox1.VertScrollBar.Range := image1.picture.Height;
 end;
end;

procedure TFODGEFullsize.FormShow(Sender: TObject);
begin
scrollbox1.HorzScrollBar.Range := image1.picture.Width;
scrollbox1.VertScrollBar.Range := image1.picture.Height;
end;

end.

